set(SEARCH_METHODS ESM AESM FCLK ICLK FALK IALK FCGD PF GNN)
set(SEARCH_METHODS_NT ESM FCLK ICLK FALK IALK)
set(COMPOSITE_SEARCH_METHODS GridTracker GridTrackerCV  RKLT CascadeTracker CascadeSM ParallelTracker ParallelSM)
find_package(FLANN)
find_package(HDF5)
if(FLANN_FOUND AND HDF5_FOUND) 
set(SEARCH_METHODS ${SEARCH_METHODS} NN)
set(MTF_LIBS ${MTF_LIBS} ${FLANN_LIBS} ${HDF5_LIBRARIES})
else()
message(STATUS "FLANN/HDF5 library not found so NN search method has been disabled")
set(MTF_RUNTIME_FLAGS ${MTF_RUNTIME_FLAGS} -DDISABLE_NN)
endif()
set(SEARCH_METHODS ${SEARCH_METHODS} ${COMPOSITE_SEARCH_METHODS})

addPrefix("${SEARCH_METHODS_NT}" "NT/" SEARCH_METHODS_NT)
set(SEARCH_METHODS ${SEARCH_METHODS} ${SEARCH_METHODS_NT})

addPrefixAndSuffix("${SEARCH_METHODS}" "SM/src/" ".cc" SEARCH_METHODS_SRC)
set(MTF_SRC ${MTF_SRC} ${SEARCH_METHODS_SRC})
set(MTF_INCLUDE_DIRS ${MTF_INCLUDE_DIRS} SM/include)
