PFSL3_ROOT_DIR = ThirdParty/PFSL3
PFSL3_SRC_DIR = ${PFSL3_ROOT_DIR}/src
PFSL3_INCLUDE_DIR = ${PFSL3_ROOT_DIR}/include
PFSL3_HEADER_DIR = ${PFSL3_INCLUDE_DIR}/mtf/${PFSL3_ROOT_DIR}

PFSL3_HEADERS = $(addprefix  ${PFSL3_HEADER_DIR}/, PFSL3.h)

pfsl3 ?= 1

ifeq (${o}, 1)
OPT_FLAGS_PFSL3 = -O3 -D NDEBUG
PFSL3_EXE_NAME= pfsl3
else
OPT_FLAGS_PFSL3 = -g -O0
PFSL3_EXE_NAME= pfsl3d
endif

ifeq (${pfsl3}, 0)
THIRD_PARTY_RUNTIME_FLAGS += -D DISABLE_PFSL3
else
THIRD_PARTY_TRACKERS += PFSL3
THIRD_PARTY_HEADERS += ${PFSL3_HEADERS}
THIRD_PARTY_INCLUDE_DIRS += ${PFSL3_INCLUDE_DIR}
THIRD_PARTY_LIBS += -llapack -lblas -lf2c
endif

PFSL3_EXE_INSTALL_DIR = /usr/local/bin
.PHONY: pfsl3
pfsl3: 	${PFSL3_EXE_INSTALL_DIR}/${PFSL3_EXE_NAME}

${BUILD_DIR}/PFSL3.o: ${PFSL3_SRC_DIR}/PFSL3.cc ${PFSL3_HEADERS} ${ROOT_HEADER_DIR}/TrackerBase.h
	${CXX} -fPIC -c -I/usr/include/clapack ${WARNING_FLAGS} ${OPT_FLAGS} $< ${FLAGS64} ${FLAGSCV} -o  $@	
ThirdParty/PFSL3/libpfsl3.a: ThirdParty/PFSL3/PFSL3.o
	ar rcs $@ $<
${MTF_LIB_INSTALL_DIR}/libpfsl3.a: ThirdParty/PFSL3/libpfsl3.a
	sudo cp -f $< $@
${PFSL3_EXE_INSTALL_DIR}/${PFSL3_EXE_NAME}: ${BUILD_DIR}/${PFSL3_EXE_NAME}
	sudo cp -f $< $@
${BUILD_DIR}/${PFSL3_EXE_NAME}: ${PFSL3_SRC_DIR}/tracking.cpp
	${CXX} -w ${WARNING_FLAGS} -o $@ -I/usr/include/clapack ${OPT_FLAGS_PFSL3} ${FLAGSCV} $< ${LIBSCV} -llapack -lblas -lf2c
