STRUCK_ROOT_DIR = ThirdParty/Struck
STRUCK_SRC_DIR = ${STRUCK_ROOT_DIR}/src
STRUCK_INCLUDE_DIR = ${STRUCK_ROOT_DIR}/include
STRUCK_HEADER_DIR = ${STRUCK_INCLUDE_DIR}/mtf/${STRUCK_ROOT_DIR}

STRUCK_HEADERS = $(addprefix  ${STRUCK_HEADER_DIR}/, Struck.h)

STRUCK_LIB_MODULES = Tracker Config Features HaarFeature HaarFeatures HistogramFeatures ImageRep LaRank MultiFeatures RawFeatures Sampler
STRUCK_LIB_INCLUDES = Kernels Rect Sample
STRUCK_LIB_HEADERS = $(addprefix ${STRUCK_HEADER_DIR}/,$(addsuffix .h, ${STRUCK_LIB_MODULES} ${STRUCK_LIB_INCLUDES}))
STRUCK_LIB_SRC = $(addprefix ${STRUCK_SRC_DIR}/,$(addsuffix .cpp, ${STRUCK_LIB_MODULES}))

THIRD_PARTY_TRACKERS += Struck
_THIRD_PARTY_TRACKERS_SO += struck
THIRD_PARTY_HEADERS += ${STRUCK_HEADERS} ${STRUCK_LIB_HEADERS} 
THIRD_PARTY_INCLUDE_DIRSTHIRD_PARTY_INCLUDE_DIRS += ${STRUCK_INCLUDE_DIR}
THIRD_PARTY_INCLUDE_DIRS += ${STRUCK_INCLUDE_DIR}

${BUILD_DIR}/Struck.o: ${STRUCK_SRC_DIR}/Struck.cc ${STRUCK_HEADERS} ${ROOT_HEADER_DIR}/TrackerBase.h
	${CXX} -c -fPIC ${WARNING_FLAGS} ${OPT_FLAGS} ${CT_FLAGS} $< ${FLAGS64} ${FLAGSCV} -I${STRUCK_INCLUDE_DIR} -I${ROOT_INCLUDE_DIR} -o $@
	
${MTF_LIB_INSTALL_DIR}/libstruck.so: ${STRUCK_ROOT_DIR}/libstruck.so
	sudo cp -f $< $@	
${STRUCK_ROOT_DIR}/libstruck.so: ${STRUCK_LIB_SRC} ${STRUCK_LIB_HEADERS}
	cd ${STRUCK_ROOT_DIR}; rm -rf Build; mkdir Build; cd Build; cmake ..
	$(MAKE) -C ${STRUCK_ROOT_DIR}/Build --no-print-directory
	mv ${STRUCK_ROOT_DIR}/Build/libstruck.so ${STRUCK_ROOT_DIR}/	